diff --git a/include/linux/crypto.h b/include/linux/crypto.h
index b164da5e129e..0f808963c562 100644
--- a/include/linux/crypto.h
+++ b/include/linux/crypto.h
@@ -113,7 +113,7 @@
  *	- crypto_ahash_finup() must not be used unless the algorithm implements
  *	  ->finup() natively.
  */
-#define CRYPTO_ALG_ALLOCATES_MEMORY	0x00010000
+#define CRYPTO_ALG_ALLOCATES_MEMORY	0x00000000
 
 /*
  * Mark an algorithm as a service implementation only usable by a
diff --git a/include/crypto/algapi.h b/include/crypto/algapi.h
index 7a4a71af653f..b20aea8047da 100644
--- a/include/crypto/algapi.h
+++ b/include/crypto/algapi.h
@@ -238,9 +238,7 @@ static inline u32 crypto_requires_off(struct crypto_attr_type *algt, u32 off)
  * template), these are the flags that should always be set on the "outer"
  * algorithm if any "inner" algorithm has them set.
  */
-#define CRYPTO_ALG_INHERITED_FLAGS	\
-	(CRYPTO_ALG_ASYNC | CRYPTO_ALG_NEED_FALLBACK |	\
-	 CRYPTO_ALG_ALLOCATES_MEMORY)
+#define CRYPTO_ALG_INHERITED_FLAGS	CRYPTO_ALG_ASYNC
 
 /*
  * Given the type and mask that specify the flags restrictions on a template